import { ILayer, IRendererService, IMapService, ISubLayerInitOptions } from '@antv/l7-core';
import { Tile } from '@antv/l7-utils';
import { ITileFactory } from '../tileFactory';
export declare class Base {
    sourceLayer: string;
    parent: ILayer;
    children: ILayer[];
    mapService: IMapService;
    rendererService: IRendererService;
    protected tileFactory: ITileFactory;
    protected initOptions: ISubLayerInitOptions;
    private tileCache;
    hasTile(tile: Tile): boolean;
    addTile(tile: Tile): {
        layers: ILayer[];
        layerIDList: string[];
    };
    removeTile(tile: Tile): void;
    addChild(layer: ILayer): void;
    addChildren(layers: ILayer[]): void;
    removeChildren(layerIDList: string[], refresh?: boolean): void;
    removeChild(layer: ILayer): void;
    getChildren(layerIDList: string[]): ILayer[];
    getChild(layerID: string): ILayer;
    clearChild(): void;
    hasChild(layer: ILayer): boolean;
    initTileFactory(): void;
    getSourceLayer(parentParserType: string, sourceLayer: string | undefined): string | undefined;
    destroy(): void;
}
