import { IInteractionTarget, ILayer, IMapService, IPickingService, IRendererService, ITileLayerManager, ITilePickService, ITileRenderService, ITransform } from '@antv/l7-core';
import { Base } from './base';
import { ITileStyleService } from '../style/TileStyleService';
export declare class TileLayerManager extends Base implements ITileLayerManager {
    tilePickService: ITilePickService;
    tileStyleService: ITileStyleService;
    tileRenderService: ITileRenderService;
    private transforms;
    constructor(parent: ILayer, mapService: IMapService, rendererService: IRendererService, pickingService: IPickingService, transforms: ITransform[]);
    render(): void;
    pickLayers(target: IInteractionTarget): boolean;
    private setSubLayerInitOption;
    private getInitOptionValue;
    private setInitOptionValue;
    private setConfigListener;
    private updateAttribute;
    private updateStyle;
    destroy(): void;
}
