import { ILayer, IMapService, IParseDataItem, IRendererService, ISubLayerInitOptions } from '@antv/l7-core';
import Source from '@antv/l7-source';
import { Tile, TilesetManager } from '@antv/l7-utils';
import { ILayerTileConfig, ITileFactory, ITileFactoryOptions, ITileStyles, Timeout } from '../interface';
export default class TileFactory implements ITileFactory {
    type: string;
    parentLayer: ILayer;
    mapService: IMapService;
    rendererService: IRendererService;
    outSideEventTimer: Timeout | null;
    protected zoomOffset: number;
    protected tilesetManager: TilesetManager;
    protected layers: ILayer[];
    private eventCache;
    constructor(option: ITileFactoryOptions);
    createTile(tile: Tile, initOptions: ISubLayerInitOptions): {
        layers: ILayer[];
        layerIDList: string[];
    };
    getFeatureData(tile: Tile, initOptions: ISubLayerInitOptions): {
        features: never[];
        featureId: null;
        vectorTileLayer: null;
        source: null;
    } | {
        features: any[];
        featureId: string | undefined;
        vectorTileLayer: any;
        source: Source;
    };
    createLayer(tileLayerOption: ILayerTileConfig): any;
    updateStyle(styles: ITileStyles): string;
    protected getTile(lng: number, lat: number): Tile;
    private bindVectorEvent;
    private readRasterTile;
    private bindRasterEvent;
    private bindCommonEvent;
    protected emitEvent(layers: ILayer[]): void;
    protected emitRasterEvent(layers: ILayer[]): void;
    protected getCombineFeature(features: IParseDataItem[]): any;
    protected getFeatureAndEmitEvent(eventName: string, e: any): void;
    private getAllFeatures;
    private getLayerInitOption;
    private handleOutsideEvent;
}
