import { IInteractionTarget, ILayer, ITileLayer, ITileLayerManager, ITileLayerOPtions } from '@antv/l7-core';
import { Base } from './base';
export declare class TileLayer extends Base implements ITileLayer {
    get children(): ILayer[];
    tileLayerManager: ITileLayerManager;
    private pickColors;
    constructor({ parent, rendererService, mapService, layerService, pickingService, transforms }: ITileLayerOPtions);
    clearPick(type: string): void;
    /**
     * 清除 select 的选中状态
     */
    clearPickState(): void;
    /**
     * 瓦片图层独立的拾取逻辑
     * @param target
     * @returns
     */
    pickLayers(target: IInteractionTarget): boolean;
    setPickState(layers: ILayer[]): void;
    private bindSubLayerPick;
    protected bindSubLayerEvent(): void;
}
