import { ILayer, IMapService, ILayerService } from '@antv/l7-core';
import { Tile, TilesetManager } from '@antv/l7-utils';
export declare class Base {
    tileLayerManager: any;
    get children(): any;
    sourceLayer: string;
    parent: ILayer;
    initedTileset: boolean;
    tilesetManager: TilesetManager | undefined;
    scaleField: any;
    protected mapService: IMapService;
    protected layerService: ILayerService;
    protected lastViewStates: {
        zoom: number;
        latLonBounds: [number, number, number, number];
    };
    protected mapchange(): void;
    protected getCurrentView(): {
        latLonBounds: [number, number, number, number];
        zoom: number;
    };
    protected initTileSetManager(): void;
    private bindTilesetEvent;
    render(): void;
    viewchange: import("lodash").DebouncedFunc<() => void>;
    tileLoaded(tile: Tile): void;
    tileError(error: Error): void;
    destroy(): void;
    tileUnLoad(tile: Tile): void;
    tileUpdate(): void;
    isTileReady(tile: Tile): boolean;
    setPickState(layers: ILayer[]): void;
}
