"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inversify = require("inversify");

require("reflect-metadata");

var _dec, _class;

var LayerModelPlugin = (
/**
 * Layer Model 初始化，更新，销毁
 */
_dec = (0, _inversify.injectable)(), _dec(_class = /*#__PURE__*/function () {
  function LayerModelPlugin() {
    (0, _classCallCheck2.default)(this, LayerModelPlugin);
  }

  (0, _createClass2.default)(LayerModelPlugin, [{
    key: "initLayerModel",
    value: function initLayerModel(layer) {
      // 更新Model 配置项
      layer.prepareBuildModel(); // 初始化 Model

      layer.buildModels();
      layer.styleNeedUpdate = false;
    }
  }, {
    key: "prepareLayerModel",
    value: function prepareLayerModel(layer) {
      var _layer$layerModel;

      // 更新Model 配置项
      layer.prepareBuildModel(); // clear layerModel resource

      (_layer$layerModel = layer.layerModel) === null || _layer$layerModel === void 0 ? void 0 : _layer$layerModel.clearModels(); // 初始化 Model

      layer.buildModels();
      layer.layerModelNeedUpdate = false;
    }
  }, {
    key: "apply",
    value: function apply(layer) {
      var _this = this;

      layer.hooks.init.tap('LayerModelPlugin', function () {
        layer.inited = true;
        layer.modelLoaded = false;
        var source = layer.getSource();

        if (source.inited) {
          _this.initLayerModel(layer);
        }
      });
      layer.hooks.beforeRenderData.tap('DataSourcePlugin', function () {
        var source = layer.getSource();
        layer.modelLoaded = false;

        if (source.inited) {
          _this.prepareLayerModel(layer);
        } else {
          source.once('update', function () {
            _this.prepareLayerModel(layer);
          });
        }

        return false;
      });
    }
  }]);
  return LayerModelPlugin;
}()) || _class);
exports.default = LayerModelPlugin;